
clear all;
clc;
for i_x = 1:size(xdata,2)   
    xtempraw(:,i_x) = transx(xdata(:,i_x),tcode(i_x)); 
end
xdata = xtempraw(2:end,:);
ydata = ydata(2:end,:);  
yearlab = yearlab(2:end);
stddata = [std(xdata) ones(1,3)];
t1 = size(xdata,1);    
t2 = size(ydata,1);    
stdffr = std(ydata(:,2));   
xdata = (xdata - repmat(mean(xdata,1),t1,1))./repmat(std(xdata),t1,1);
ydata = (ydata - repmat(mean(ydata,1),t2,1))./repmat(std(ydata),t2,1);
X = xdata;  
Y = ydata(:,:);
namesXY = [namesX ; 'Observable Variable';'AM2']; %change Observable Variable
T=size(Y,1); 
N=size(X,2); 
M=size(Y,2); 
nrep = 50000; 
nburn = 100000;   
nthin = 1;  
it_print = 100;  
constant = 1; 
TVP_Beta = 1;  
TVP_Sigma = 1; 
TVP_Alpha = 1;  
K = 1;           
tau = 0;             
p = K+M;             
plag = 2;           
numa = p*(p-1)/2;    
i_count = 0;         
[F0,Lf]=extract(X,K);
slowindex = find(slowcode==1)';
xslow = X(:,slowindex);
[Fslow0,Lfslow0] = extract(xslow,K);
Fr0 = facrot(F0,Y(:,end),Fslow0);
XY=[X,Y];  
FY=[Fr0,Y];
L = (olssvd(XY,FY))';
e = XY - FY*L';
R = e'*e./T;
R = diag(diag(R));
R = diag([diag(R);zeros(M,1)]);   
L_RE=L;
R_RE=R;
ylag = mlag2(FY,plag);
ylag = ylag(plag+tau+1:T,:);
m = p*constant + plag*(p^2); 
Z = zeros((T-tau-plag)*p,m);
for i = 1:T-tau-plag
    if constant
        ztemp = eye(p);
    else
        ztemp = []; 
    end
    for j = 1:plag
        xtemp = ylag(i,(j-1)*p+1:j*p);
        xtemp = kron(eye(p),xtemp);
        ztemp = [ztemp xtemp]; 
    end
    Z((i-1)*p+1:i*p,:) = ztemp;
end
y = FY(tau+plag+1:T,:)';
yearlab = yearlab(tau+plag+1:T);
T=size(y,2);
Li_prvar = 4*eye(p);
alpha = 0.01;
beta = 0.01;
A_OLS = zeros(numa,1);
B_OLS = zeros(m,1);
VA_OLS = eye(numa);
VB_OLS = eye(m);
sigma_OLS = ones(p,1);
k_Q = 0.007;
k_S = 0.1;
k_W = 1;
sizeQ = m; 
sizeW = p; 
sizeS = 1:p; 
B_0_prmean = B_OLS;
B_0_prvar = 4*VB_OLS;
A_0_prmean = A_OLS;
A_0_prvar = 4*VA_OLS;
sigma_prmean = sigma_OLS;
sigma_prvar = 4*eye(p);
Q_prmean = ((k_Q).^2)*(1+sizeQ)*VB_OLS;
Q_prvar = 1 + sizeQ;
W_prmean = ((k_W)^2)*ones(p,1);
W_prvar = 2;
S_prmean = cell(p-1,1);
S_prvar = zeros(p-1,1);
ind = 1;
for ii = 2:p
    S_prmean{ii-1} = ((k_S)^2)*(1 + sizeS(ii-1))*VA_OLS(((ii-1)+(ii-3)*(ii-2)/2):ind,((ii-1)+(ii-3)*(ii-2)/2):ind);
    S_prvar(ii-1) = 1 + sizeS(ii-1);
    ind = ind + ii;
end
consQ = 0.0001;
consS = 0.0001;
consH = 0.01;
consW = 0.0001;
Qdraw = consQ*eye(m);
Qchol = sqrt(consQ)*eye(m);
Ht = kron(ones(T,1),consH*eye(p));
Htsd = kron(ones(T,1),sqrt(consH)*eye(p));
Sdraw = consS*eye(numa);
Sblockdraw = cell(p-1,1);
ijc = 1;
for jj=2:p
    Sblockdraw{jj-1} = Sdraw(((jj-1)+(jj-3)*(jj-2)/2):ijc,((jj-1)+(jj-3)*(jj-2)/2):ijc);
    ijc = ijc + jj;
end
Wdraw = consW*ones(p,1);
Btdraw = 0.5*ones(m,T);
Atdraw = zeros(numa,T);
Sigtdraw = zeros(T,p);
sigt = kron(ones(T,1),0.01*eye(p));
mixdrawS = 5*ones(T,p);
Zs = kron(ones(T,1),eye(p));
Bt_postmean = zeros(m,T);
At_postmean = zeros(numa,T);
Sigt_postmean = zeros(T,p);
Qmean = zeros(m,m);
Smean = zeros(numa,numa);
Wmean = zeros(p,1);

sigmean = zeros(T,p);
cormean = zeros(T,numa);
kpmean = zeros(1,2+N);
sig2mo = zeros(T,p);
cor2mo = zeros(T,numa);
kp2mo = zeros(1,2+N);
istore = 1;
if istore == 1;
    nhor = 24;
    shock_init = diag([zeros(1,p-1) 1/stdffr]'); 
    imp9700 = zeros(nrep,N+M,nhor);
    imp9725 = zeros(nrep,N+M,nhor);
    imp9750 = zeros(nrep,N+M,nhor);
    imp9775 = zeros(nrep,N+M,nhor);
    imp9800 = zeros(nrep,N+M,nhor);
    imp9825 = zeros(nrep,N+M,nhor);
    imp9850 = zeros(nrep,N+M,nhor);
    imp9875 = zeros(nrep,N+M,nhor);
    imp9900 = zeros(nrep,N+M,nhor);
    imp9925 = zeros(nrep,N+M,nhor);
    imp9950 = zeros(nrep,N+M,nhor);
    imp9975 = zeros(nrep,N+M,nhor);
    imp0000 = zeros(nrep,N+M,nhor);
    imp0025 = zeros(nrep,N+M,nhor);
    imp0050 = zeros(nrep,N+M,nhor);
    imp0075 = zeros(nrep,N+M,nhor);
    imp0100 = zeros(nrep,N+M,nhor);
    imp0125 = zeros(nrep,N+M,nhor);
    imp0150 = zeros(nrep,N+M,nhor);
    imp0175 = zeros(nrep,N+M,nhor);
    imp0200 = zeros(nrep,N+M,nhor);
    imp0225 = zeros(nrep,N+M,nhor);
    imp0250 = zeros(nrep,N+M,nhor);
    imp0275 = zeros(nrep,N+M,nhor);
    imp0300 = zeros(nrep,N+M,nhor);
    imp0325 = zeros(nrep,N+M,nhor);
    imp0350 = zeros(nrep,N+M,nhor);
    imp0375 = zeros(nrep,N+M,nhor);
    imp0400 = zeros(nrep,N+M,nhor);
    imp0425 = zeros(nrep,N+M,nhor);
    imp0450 = zeros(nrep,N+M,nhor);
    imp0475 = zeros(nrep,N+M,nhor);
    imp0500 = zeros(nrep,N+M,nhor);
    imp0525 = zeros(nrep,N+M,nhor);
    imp0550 = zeros(nrep,N+M,nhor);
    imp0575 = zeros(nrep,N+M,nhor);
    imp0600 = zeros(nrep,N+M,nhor);
    imp0625 = zeros(nrep,N+M,nhor);
    imp0650 = zeros(nrep,N+M,nhor);
    imp0675 = zeros(nrep,N+M,nhor);
    imp0700 = zeros(nrep,N+M,nhor);
    imp0725 = zeros(nrep,N+M,nhor);
    imp0750 = zeros(nrep,N+M,nhor);
    imp0775 = zeros(nrep,N+M,nhor);
    imp0800 = zeros(nrep,N+M,nhor);
    imp0825 = zeros(nrep,N+M,nhor);
    imp0850 = zeros(nrep,N+M,nhor);
    imp0875 = zeros(nrep,N+M,nhor);
    imp0900 = zeros(nrep,N+M,nhor);
    imp0925 = zeros(nrep,N+M,nhor);
    imp0950 = zeros(nrep,N+M,nhor);
    imp0975 = zeros(nrep,N+M,nhor);
    imp1000 = zeros(nrep,N+M,nhor);
    imp1025 = zeros(nrep,N+M,nhor);
    imp1050 = zeros(nrep,N+M,nhor);
    imp1075 = zeros(nrep,N+M,nhor);
    imp1100 = zeros(nrep,N+M,nhor);
    imp1125 = zeros(nrep,N+M,nhor);
    imp1150 = zeros(nrep,N+M,nhor);
    imp1175 = zeros(nrep,N+M,nhor);
    imp1200 = zeros(nrep,N+M,nhor);
    imp1225 = zeros(nrep,N+M,nhor);
    imp1250 = zeros(nrep,N+M,nhor);
    imp1275 = zeros(nrep,N+M,nhor);
    imp1300 = zeros(nrep,N+M,nhor);
    imp1325 = zeros(nrep,N+M,nhor);
    imp1350 = zeros(nrep,N+M,nhor);
    imp1375 = zeros(nrep,N+M,nhor);
    imp1400 = zeros(nrep,N+M,nhor);
    imp1425 = zeros(nrep,N+M,nhor);
    imp1450 = zeros(nrep,N+M,nhor);
    imp1475 = zeros(nrep,N+M,nhor);
    imp1500 = zeros(nrep,N+M,nhor);
    imp1525 = zeros(nrep,N+M,nhor);
    imp1550 = zeros(nrep,N+M,nhor);
    imp1575 = zeros(nrep,N+M,nhor);
    bigj = zeros(p,p*plag);
    bigj(1:p,1:p) = eye(p);
end
tic;
disp('Number of iterations');

for irep = 1:nrep + nburn   
    if mod(irep,it_print) == 0
        disp(irep); toc;
    end
    for i=1:N
        if i > K
            Li_postvar = inv(inv(Li_prvar) + inv(R(i,i))*FY'*FY);
            Li_postmean = Li_postvar*(inv(R(i,i))*FY'*X(:,i));
            Lidraw = Li_postmean' + randn(1,p)*chol(Li_postvar);
            L(i,1:p) = Lidraw;
        end       
        ed = X(:,i) - FY*L(i,:)';
		R_1 = alpha/2 + T/2;
        R_2 = beta/2 + ((X(:,i) - FY*L(i,:)')'*(X(:,i) - FY*L(i,:)'))/2;
        Ridraw = inv(gamrnd(R_1,1/R_2));
        R(i,i) = Ridraw;
    end  
    [Btdrawc,log_likB] = carter_kohn(y,Z,Ht,Qdraw,m,p,T,B_0_prmean,B_0_prvar,TVP_Beta*ones(T,1));   
    Btdraw = Btdrawc;
    Btemp = Btdraw(:,2:T)' - Btdraw(:,1:T-1)';
    sse_2 = zeros(m,m);
    for i = 1:T-1
        sse_2 = sse_2 + Btemp(i,:)'*Btemp(i,:);
    end

    Qinv = inv(sse_2 + Q_prmean);
    Qinvdraw = wish(Qinv,T + Q_prvar);
    if TVP_Beta
        Qdraw = inv(Qinvdraw); 
        Qchol = chol(Qdraw);
    else
        Qdraw = zeros(m,m);
    end
    yhat = zeros(p,T);
    for i = 1:T
        yhat(:,i) = y(:,i) - Z((i-1)*p+1:i*p,:)*Btdraw(:,i);
    end
    Zc = - yhat(:,:)';
    sigma2temp = exp(Sigtdraw);
    
    Atdraw = [];
    ind = 1;
    for ii = 2:p
        [Atblockdraw,log_lik2a] = carter_kohn(yhat(ii,:),Zc(:,1:ii-1),sigma2temp(:,ii),...
            Sblockdraw{ii-1},sizeS(ii-1),1,T,A_0_prmean(((ii-1)+(ii-3)*(ii-2)/2):ind,:),A_0_prvar(((ii-1)+(ii-3)*(ii-2)/2):ind,((ii-1)+(ii-3)*(ii-2)/2):ind),TVP_Alpha*ones(T,1));
        Atdraw = [Atdraw ; Atblockdraw];
        ind = ind + ii;
    end
    Attemp = Atdraw(:,2:T)' - Atdraw(:,1:T-1)';
    sse_2 = zeros(numa,numa);
    for i = 1:T-1
        sse_2 = sse_2 + Attemp(i,:)'*Attemp(i,:);
    end
    
    ijc = 1;
    for jj=2:p
        Sinv = inv(sse_2(((jj-1)+(jj-3)*(jj-2)/2):ijc,((jj-1)+(jj-3)*(jj-2)/2):ijc) + S_prmean{jj-1});
        Sinvblockdraw = wish(Sinv,T+S_prvar(jj-1));
        Sblockdraw{jj-1} = inv(Sinvblockdraw);
        ijc = ijc + jj;
    end
    capAt = zeros(p*T,p);
    for i = 1:T
        capatemp = eye(p);
        aatemp = Atdraw(:,i);
        ic=1;
        for j = 2:p
            capatemp(j,1:j-1) = aatemp(ic:ic+j-2,1)';
            ic = ic + j - 1;
        end
        capAt((i-1)*p+1:i*p,:) = capatemp;
    end

    y2 = [];
    for i = 1:T
        ytemps = capAt((i-1)*p+1:i*p,:)*yhat(:,i);
        y2 = [y2  (ytemps.^2)]; 
    end   

    yss = log(y2 + 1e-6)';
    for j=1:p
        [Sigtdraw(:,j) , statedraw(:,j)] = SVRW2(yss(:,j),Sigtdraw(:,j),Wdraw(j,:),sigma_prmean(j),sigma_prvar(j,j),TVP_Sigma);
    end
    sigt = exp(.5*Sigtdraw);
    
    e2 = Sigtdraw(2:end,:) - Sigtdraw(1:end-1,:);
    W1 = W_prvar + T - plag - 1;
    W2 = W_prmean + sum(e2.^2)';
    Winvdraw = gamrnd(W1./2,2./W2);
    Wdrawc = 1./Winvdraw;
    if TVP_Sigma 
        Wdraw = Wdrawc;
    else
        Wdraw = zeros(p,p); 
    end

    Ht = zeros(p*T,p);
    Htsd = zeros(p*T,p);
    for i = 1:T
        inva = inv(capAt((i-1)*p+1:i*p,:));
        stem = diag(sigt(i,:));
        Hsd = inva*stem;
        Hdraw = Hsd*Hsd';
        Ht((i-1)*p+1:i*p,:) = Hdraw;
        Htsd((i-1)*p+1:i*p,:) = Hsd;
    end
    if irep > nburn && mod((irep-nburn),nthin)==0 
        i_count = i_count + 1;
        Bt_postmean = Bt_postmean + Btdraw;
        At_postmean = At_postmean + Atdraw;
        Sigt_postmean = Sigt_postmean + Sigtdraw;
        Qmean = Qmean + Qdraw;
        ikc = 1;
        for kk = 2:p
            Sdraw(((kk-1)+(kk-3)*(kk-2)/2):ikc,((kk-1)+(kk-3)*(kk-2)/2):ikc)=Sblockdraw{kk-1};
            ikc = ikc + kk;
        end
        Smean = Smean + Sdraw;
        Wmean = Wmean + Wdraw;
        stemp6 = zeros(p,1);
        stemp5 = [];
        stemp7 = [];
        for i = 1:T
            stemp8 = corrvc(Ht((i-1)*p+1:i*p,:));
            stemp7a = [];
            ic = 1;
            for j = 1:p
                if j>1;
                    stemp7a = [stemp7a ; stemp8(j,1:ic)']; 
                    ic = ic+1;
                end
                stemp6(j,1) = sqrt(Ht((i-1)*p+j,j));
            end
            stemp5 = [stemp5 ; stemp6']; 
            stemp7 = [stemp7 ; stemp7a']; 
        end
        sigmean = sigmean + stemp5;
        cormean =cormean + stemp7; 
        sig2mo = sig2mo + stemp5.^2;
        cor2mo = cor2mo + stemp7.^2;
        if istore==1;
            k = size(Btdraw,1);
            biga = zeros(p*plag,p*plag);
            for j = 1:plag-1
                biga(j*p+1:p*(j+1),p*(j-1)+1:j*p) = eye(p);
            end

            for i = 1:T 
                bbtemp = Btdraw(p*constant + 1:k,i);
                splace = 0;
                for ii = 1:plag
                    for iii = 1:p
                        biga(iii,(ii-1)*p+1:ii*p) = bbtemp(splace+1:splace+p,1)';
                        splace = splace + p;
                    end
                end
                Hsd = chol(Ht((i-1)*p+1:i*p,1:p))';
                d = diag(diag(Hsd));
                shock = inv(d)*Hsd;
                impresp = zeros(p,p*nhor);
                impresp(1:p,1:p) = shock;
                bigai = biga;
                for j = 1:nhor-1
                    impresp(:,j*p+1:(j+1)*p) = bigj*bigai*bigj'*shock;
                    bigai = bigai*biga;
                end
                if yearlab(i,1) == 1997.00;         
                    imp9700_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp9700_m(:,ij) = impresp(:,jj);
                    end
                    imp9700(i_count,:,:) = L_RE*imp9700_m;                    
                end 
                if yearlab(i,1) == 1997.25;         
                    imp9725_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp9725_m(:,ij) = impresp(:,jj);
                    end
                    imp9725(i_count,:,:) = L_RE*imp9725_m;                    
                end 
                if yearlab(i,1) == 1997.50;         
                    imp9750_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp9750_m(:,ij) = impresp(:,jj);
                    end
                    imp9750(i_count,:,:) = L_RE*imp9750_m;                    
                end 
                if yearlab(i,1) == 1997.75;         
                    imp9775_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp9775_m(:,ij) = impresp(:,jj);
                    end
                    imp9775(i_count,:,:) = L_RE*imp9775_m;                    
                end 
                if yearlab(i,1) == 1998.00;         
                    imp9800_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp9800_m(:,ij) = impresp(:,jj);
                    end
                    imp9800(i_count,:,:) = L_RE*imp9800_m;                    
                end 
                if yearlab(i,1) == 1998.25;         
                    imp9825_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp9825_m(:,ij) = impresp(:,jj);
                    end
                    imp9825(i_count,:,:) = L_RE*imp9825_m;                    
                end 
                if yearlab(i,1) == 1998.50;         
                    imp9850_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp9850_m(:,ij) = impresp(:,jj);
                    end
                    imp9850(i_count,:,:) = L_RE*imp9850_m;                    
                end 
                if yearlab(i,1) == 1998.75;          
                    imp9875_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp9875_m(:,ij) = impresp(:,jj);
                    end
                    imp9875(i_count,:,:) = L_RE*imp9875_m;                    
                end 
                if yearlab(i,1) == 1999.00;          
                    imp9900_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp9900_m(:,ij) = impresp(:,jj);
                    end
                    imp9900(i_count,:,:) = L_RE*imp9900_m;                    
                end 
                if yearlab(i,1) == 1999.25;          
                    imp9925_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp9925_m(:,ij) = impresp(:,jj);
                    end
                    imp9925(i_count,:,:) = L_RE*imp9925_m;                    
                end 
                if yearlab(i,1) == 1999.50;          
                    imp9950_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp9950_m(:,ij) = impresp(:,jj);
                    end
                    imp9950(i_count,:,:) = L_RE*imp9950_m;                    
                end 
                if yearlab(i,1) == 1999.75;          
                    imp9975_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp9975_m(:,ij) = impresp(:,jj);
                    end
                    imp9975(i_count,:,:) = L_RE*imp9975_m;                    
                end 
                if yearlab(i,1) == 2000.00;        
                    imp0000_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0000_m(:,ij) = impresp(:,jj);
                    end
                    imp0000(i_count,:,:) = L_RE*imp0000_m;                    
                end 
                if yearlab(i,1) == 2000.25;        
                    imp0025_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0025_m(:,ij) = impresp(:,jj);
                    end
                    imp0025(i_count,:,:) = L_RE*imp0025_m;                    
                end 
                if yearlab(i,1) == 2000.50;        
                    imp0050_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0050_m(:,ij) = impresp(:,jj);
                    end
                    imp0050(i_count,:,:) = L_RE*imp0050_m;                    
                end 
                if yearlab(i,1) == 2000.75;        
                    imp0075_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0075_m(:,ij) = impresp(:,jj);
                    end
                    imp0075(i_count,:,:) = L_RE*imp0075_m;                    
                end 
                if yearlab(i,1) == 2001.00;        
                    imp0100_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0100_m(:,ij) = impresp(:,jj);
                    end
                    imp0100(i_count,:,:) = L_RE*imp0100_m;                    
                end
                 if yearlab(i,1) == 2001.25;        
                    imp0125_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0125_m(:,ij) = impresp(:,jj);
                    end
                    imp0125(i_count,:,:) = L_RE*imp0125_m;                    
                end
                 if yearlab(i,1) == 2001.50;        
                    imp0150_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0150_m(:,ij) = impresp(:,jj);
                    end
                    imp0150(i_count,:,:) = L_RE*imp0150_m;                    
                end
                 if yearlab(i,1) == 2001.75;        
                    imp0175_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0175_m(:,ij) = impresp(:,jj);
                    end
                    imp0175(i_count,:,:) = L_RE*imp0175_m;                    
                end
  
                if yearlab(i,1) == 2002.00;         
                    imp0200_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0200_m(:,ij) = impresp(:,jj);
                    end
                    imp0200(i_count,:,:) = L_RE*imp0200_m;                    
                end 
                if yearlab(i,1) == 2002.25;          
                    imp0225_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0225_m(:,ij) = impresp(:,jj);
                    end
                    imp0225(i_count,:,:) = L_RE*imp0225_m;                    
                end 
                if yearlab(i,1) == 2002.50;          
                    imp0250_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0250_m(:,ij) = impresp(:,jj);
                    end
                    imp0250(i_count,:,:) = L_RE*imp0250_m;                    
                end 
                if yearlab(i,1) == 2002.75;         
                    imp0275_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0275_m(:,ij) = impresp(:,jj);
                    end
                    imp0275(i_count,:,:) = L_RE*imp0275_m;                    
                end 

                if yearlab(i,1) == 2003.00;          
                    imp0300_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0300_m(:,ij) = impresp(:,jj);
                    end
                    imp0300(i_count,:,:) = L_RE*imp0300_m;                    
                end 
                if yearlab(i,1) == 2003.25;          
                    imp0325_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0325_m(:,ij) = impresp(:,jj);
                    end
                    imp0325(i_count,:,:) = L_RE*imp0325_m;                    
                end 
                if yearlab(i,1) == 2003.50;          
                    imp0350_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0350_m(:,ij) = impresp(:,jj);
                    end
                    imp0350(i_count,:,:) = L_RE*imp0350_m;                    
                end 
                if yearlab(i,1) == 2003.75;          
                    imp0375_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0375_m(:,ij) = impresp(:,jj);
                    end
                    imp0375(i_count,:,:) = L_RE*imp0375_m;                    
                end 
 
                if yearlab(i,1) == 2004.00;        
                    imp0400_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0400_m(:,ij) = impresp(:,jj);
                    end
                    imp0400(i_count,:,:) = L_RE*imp0400_m;                    
                end 
                if yearlab(i,1) == 2004.25;        
                    imp0425_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0425_m(:,ij) = impresp(:,jj);
                    end
                    imp0425(i_count,:,:) = L_RE*imp0425_m;                    
                end 
                if yearlab(i,1) == 2004.50;        
                    imp0450_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0450_m(:,ij) = impresp(:,jj);
                    end
                    imp0450(i_count,:,:) = L_RE*imp0450_m;                    
                end 
                if yearlab(i,1) == 2004.75;        
                    imp0475_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0475_m(:,ij) = impresp(:,jj);
                    end
                    imp0475(i_count,:,:) = L_RE*imp0475_m;                    
                end 

                if yearlab(i,1) == 2005.00;        
                    imp0500_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0500_m(:,ij) = impresp(:,jj);
                    end
                    imp0500(i_count,:,:) = L_RE*imp0500_m;                    
                end
                 if yearlab(i,1) == 2005.25;        
                    imp0525_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0525_m(:,ij) = impresp(:,jj);
                    end
                    imp0525(i_count,:,:) = L_RE*imp0525_m;
                 end
                if yearlab(i,1) == 2005.50;        
                    imp0550_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0550_m(:,ij) = impresp(:,jj);
                    end
                    imp0550(i_count,:,:) = L_RE*imp0550_m;                    
                end
                if yearlab(i,1) == 2005.75;        
                    imp0575_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0575_m(:,ij) = impresp(:,jj);
                    end
                    imp0575(i_count,:,:) = L_RE*imp0575_m;                    
                end

                if yearlab(i,1) == 2006.00;        
                    imp0600_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0600_m(:,ij) = impresp(:,jj);
                    end
                    imp0600(i_count,:,:) = L_RE*imp0600_m;                    
                end 
                if yearlab(i,1) == 2006.25;        
                    imp0625_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0625_m(:,ij) = impresp(:,jj);
                    end
                    imp0625(i_count,:,:) = L_RE*imp0625_m;                    
                end 
                if yearlab(i,1) == 2006.50;        
                    imp0650_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0650_m(:,ij) = impresp(:,jj);
                    end
                    imp0650(i_count,:,:) = L_RE*imp0650_m;                    
                end 
                if yearlab(i,1) == 2006.75;        
                    imp0675_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0675_m(:,ij) = impresp(:,jj);
                    end
                    imp0675(i_count,:,:) = L_RE*imp0675_m;                    
                end 

                if yearlab(i,1) == 2007.00;        
                    imp0700_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0700_m(:,ij) = impresp(:,jj);
                    end
                    imp0700(i_count,:,:) = L_RE*imp0700_m;                    
                end    
                if yearlab(i,1) == 2007.25;        
                    imp0725_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0725_m(:,ij) = impresp(:,jj);
                    end
                    imp0725(i_count,:,:) = L_RE*imp0725_m;                    
                end 
                if yearlab(i,1) == 2007.50;        
                    imp0750_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0750_m(:,ij) = impresp(:,jj);
                    end
                    imp0750(i_count,:,:) = L_RE*imp0750_m;                    
                end 
                if yearlab(i,1) == 2007.75;        
                    imp0775_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0775_m(:,ij) = impresp(:,jj);
                    end
                    imp0775(i_count,:,:) = L_RE*imp0775_m;                    
                end 

                if yearlab(i,1) == 2008.00;
                    imp0800_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0800_m(:,ij) = impresp(:,jj);
                    end
                    imp0800(i_count,:,:) = L_RE*imp0800_m;               
                end
                if yearlab(i,1) == 2008.25;
                    imp0825_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp025_m(:,ij) = impresp(:,jj);
                    end
                    imp0825(i_count,:,:) = L_RE*imp0825_m;               
                end
                if yearlab(i,1) == 2008.50;
                    imp0850_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0850_m(:,ij) = impresp(:,jj);
                    end
                    imp0850(i_count,:,:) = L_RE*imp0850_m;               
                end
                if yearlab(i,1) == 2008.75;
                    imp0875_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0875_m(:,ij) = impresp(:,jj);
                    end
                    imp0875(i_count,:,:) = L_RE*imp0875_m;               
                end

                if yearlab(i,1) == 2009.00;
                    imp0900_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0900_m(:,ij) = impresp(:,jj);
                    end
                    imp0900(i_count,:,:) = L_RE*imp0900_m;               
                end
                 if yearlab(i,1) == 2009.25;
                    imp0925_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0925_m(:,ij) = impresp(:,jj);
                    end
                    imp0925(i_count,:,:) = L_RE*imp0925_m;               
                 end
                 if yearlab(i,1) == 2009.50;
                    imp0950_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0950_m(:,ij) = impresp(:,jj);
                    end
                    imp0950(i_count,:,:) = L_RE*imp0950_m;               
                end
                if yearlab(i,1) == 2009.75;
                    imp0975_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp0975_m(:,ij) = impresp(:,jj);
                    end
                    imp0975(i_count,:,:) = L_RE*imp0975_m;               
                end              
                                
                if yearlab(i,1) == 2010.00;        
                    imp1000_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1000_m(:,ij) = impresp(:,jj);
                    end
                    imp1000(i_count,:,:) = L_RE*imp1000_m;                    
                end
                if yearlab(i,1) == 2010.25;        
                    imp1025_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1025_m(:,ij) = impresp(:,jj);
                    end
                    imp1025(i_count,:,:) = L_RE*imp1025_m;                    
                end
                if yearlab(i,1) == 2010.50;        
                    imp1050_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1050_m(:,ij) = impresp(:,jj);
                    end
                    imp1050(i_count,:,:) = L_RE*imp1050_m;                    
                end
                if yearlab(i,1) == 2010.75;        
                    imp1075_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1075_m(:,ij) = impresp(:,jj);
                    end
                    imp1075(i_count,:,:) = L_RE*imp1075_m;                    
                end
                
                if yearlab(i,1) == 2011.00;        
                    imp1100_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1100_m(:,ij) = impresp(:,jj);
                    end
                    imp1100(i_count,:,:) = L_RE*imp1100_m;                    
                end 
                if yearlab(i,1) == 2011.25;        
                    imp1125_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1125_m(:,ij) = impresp(:,jj);
                    end
                    imp1125(i_count,:,:) = L_RE*imp1125_m;                    
                end 
                if yearlab(i,1) == 2011.50;        
                    imp1150_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1150_m(:,ij) = impresp(:,jj);
                    end
                    imp1150(i_count,:,:) = L_RE*imp1150_m;                    
                end 
                if yearlab(i,1) == 2011.75;        
                    imp1175_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1175_m(:,ij) = impresp(:,jj);
                    end
                    imp1175(i_count,:,:) = L_RE*imp1175_m;                    
                end 

                if yearlab(i,1) == 2012.00;        
                    imp1200_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1200_m(:,ij) = impresp(:,jj);
                    end
                    imp1200(i_count,:,:) = L_RE*imp1200_m;                    
                end 
                if yearlab(i,1) == 2012.25;        
                    imp1225_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1225_m(:,ij) = impresp(:,jj);
                    end
                    imp1225(i_count,:,:) = L_RE*imp1225_m;                    
                end
                if yearlab(i,1) == 2012.50;        
                    imp1250_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1250_m(:,ij) = impresp(:,jj);
                    end
                    imp1250(i_count,:,:) = L_RE*imp1250_m;                    
                end
                if yearlab(i,1) == 2012.75;        
                    imp1275_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1275_m(:,ij) = impresp(:,jj);
                    end
                    imp1275(i_count,:,:) = L_RE*imp1275_m;                    
                end

                if yearlab(i,1) == 2013.00;
                    imp1300_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1300_m(:,ij) = impresp(:,jj);
                    end
                    imp1300(i_count,:,:) = L_RE*imp1300_m;               
                end
                if yearlab(i,1) == 2013.25;
                    imp1325_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1325_m(:,ij) = impresp(:,jj);
                    end
                    imp1325(i_count,:,:) = L_RE*imp1325_m;               
                end
                if yearlab(i,1) == 2013.50;
                    imp1350_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1350_m(:,ij) = impresp(:,jj);
                    end
                    imp1350(i_count,:,:) = L_RE*imp1350_m;               
                end
                if yearlab(i,1) == 2013.75;
                    imp1375_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1375_m(:,ij) = impresp(:,jj);
                    end
                    imp1375(i_count,:,:) = L_RE*imp1375_m;               
                end

                if yearlab(i,1) == 2014.00;
                    imp1400_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1400_m(:,ij) = impresp(:,jj);
                    end
                    imp1400(i_count,:,:) = L_RE*imp1400_m;               
                end
                if yearlab(i,1) == 2014.25;
                    imp1425_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1425_m(:,ij) = impresp(:,jj);
                    end
                    imp1425(i_count,:,:) = L_RE*imp1425_m;               
                end
                if yearlab(i,1) == 2014.50;
                    imp1450_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1450_m(:,ij) = impresp(:,jj);
                    end
                    imp1450(i_count,:,:) = L_RE*imp1450_m;               
                end
                if yearlab(i,1) == 2014.75;
                    imp1475_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1475_m(:,ij) = impresp(:,jj);
                    end
                    imp1475(i_count,:,:) = L_RE*imp1475_m;               
                end

                if yearlab(i,1) == 2015.00;
                    imp1500_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1500_m(:,ij) = impresp(:,jj);
                    end
                    imp1500(i_count,:,:) = L_RE*imp1500_m;  
                end
                if yearlab(i,1) == 2015.25;
                    imp1525_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1525_m(:,ij) = impresp(:,jj);
                    end
                    imp1525(i_count,:,:) = L_RE*imp1525_m;  
                end
                if yearlab(i,1) == 2015.50;
                    imp1550_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1550_m(:,ij) = impresp(:,jj);
                    end
                    imp1550(i_count,:,:) = L_RE*imp1550_m;  
                end
                if yearlab(i,1) == 2015.75;
                    imp1575_m = zeros(p,nhor);
                    jj=0;
                    for ij = 1:nhor
                        jj = jj + p;
                        imp1575_m(:,ij) = impresp(:,jj);
                    end
                    imp1575(i_count,:,:) = L_RE*imp1575_m;  
                end  
            end 
        end   

    end 
end 
save gov.mat
nrep = i_count;
Bt_postmean = Bt_postmean./nrep;
At_postmean = At_postmean./nrep;
Sigt_postmean = Sigt_postmean./nrep;
Qmean = Qmean./nrep;
Smean = Smean./nrep;
Wmean = Wmean./nrep;
sigmean = sigmean./nrep;
cormean = cormean./nrep;
sig2mo = sig2mo./nrep;
cor2mo = cor2mo./nrep;      
    scale=repmat(stddata',[1 3 20]);
    scale=permute(scale,[2 1 3])   
    imp9700 = permute(imp9700,[2 3 1]);
    imp9725 = permute(imp9725,[2 3 1]);
    imp9750 = permute(imp9750,[2 3 1]);
    imp9775 = permute(imp9775,[2 3 1]);
    imp9800 = permute(imp9800,[2 3 1]);
    imp9825 = permute(imp9825,[2 3 1]);
    imp9850 = permute(imp9850,[2 3 1]);
    imp9875 = permute(imp9875,[2 3 1]);
    imp9900 = permute(imp9900,[2 3 1]);
    imp9925= permute(imp9925,[2 3 1]);
    imp9950 = permute(imp9950,[2 3 1]);
    imp9975 = permute(imp9975,[2 3 1]);
    imp0000 = permute(imp0000,[2 3 1]);
    imp0025 = permute(imp0025,[2 3 1]);
    imp0050 = permute(imp0050,[2 3 1]);
    imp0075 = permute(imp0075,[2 3 1]);
    imp0100 = permute(imp0100,[2 3 1]);
    imp0125 = permute(imp0125,[2 3 1]);
    imp0150 = permute(imp0150,[2 3 1]);
    imp0175 = permute(imp0175,[2 3 1]);
    imp0200 = permute(imp0200,[2 3 1]);
    imp0225 = permute(imp0225,[2 3 1]);
    imp0250 = permute(imp0250,[2 3 1]);
    imp0275 = permute(imp0275,[2 3 1]);
    imp0300 = permute(imp0300,[2 3 1]);
    imp0325 = permute(imp0325,[2 3 1]);
    imp0350 = permute(imp0350,[2 3 1]);
    imp0375 = permute(imp0375,[2 3 1]);
    imp0400 = permute(imp0400,[2 3 1]);
    imp0425 = permute(imp0425,[2 3 1]);
    imp0450 = permute(imp0450,[2 3 1]);
    imp0475 = permute(imp0475,[2 3 1]);
    imp0500 = permute(imp0500,[2 3 1]);
    imp0525 = permute(imp0525,[2 3 1]);
    imp0550 = permute(imp0550,[2 3 1]);
    imp0575 = permute(imp0575,[2 3 1]);
    imp0600 = permute(imp0600,[2 3 1]);
    imp0625 = permute(imp0625,[2 3 1]);
    imp0650 = permute(imp0650,[2 3 1]);
    imp0675 = permute(imp0675,[2 3 1]);
    imp0700 = permute(imp0700,[2 3 1]);
    imp0725 = permute(imp0725,[2 3 1]);
    imp0750 = permute(imp0750,[2 3 1]);
    imp0775 = permute(imp0775,[2 3 1]);
    imp0800 = permute(imp0800,[2 3 1]);
    imp0825 = permute(imp0825,[2 3 1]);
    imp0850 = permute(imp0850,[2 3 1]);
    imp0875 = permute(imp0875,[2 3 1]);
    imp0900 = permute(imp0900,[2 3 1]);
    imp0925 = permute(imp0925,[2 3 1]);
    imp0950 = permute(imp0950,[2 3 1]);
    imp0975 = permute(imp0975,[2 3 1]);
    imp1000 = permute(imp1000,[2 3 1]);
    imp1025 = permute(imp1025,[2 3 1]);
    imp1050 = permute(imp1050,[2 3 1]);
    imp1075 = permute(imp1075,[2 3 1]);
    imp1100 = permute(imp1100,[2 3 1]);
    imp1125 = permute(imp1125,[2 3 1]);
    imp1150 = permute(imp1150,[2 3 1]);
    imp1175 = permute(imp1175,[2 3 1]);
    imp1200 = permute(imp1200,[2 3 1]);
    imp1225 = permute(imp1225,[2 3 1]);
    imp1250 = permute(imp1250,[2 3 1]);
    imp1275 = permute(imp1275,[2 3 1]);
    imp1300 = permute(imp1300,[2 3 1]);
    imp1325 = permute(imp1325,[2 3 1]);
    imp1350 = permute(imp1350,[2 3 1]);
    imp1375 = permute(imp1375,[2 3 1]);
    imp1400 = permute(imp1400,[2 3 1]);
    imp1425 = permute(imp1425,[2 3 1]);
    imp1450 = permute(imp1450,[2 3 1]);
    imp1475 = permute(imp1475,[2 3 1]);
    imp1500 = permute(imp1500,[2 3 1]);
    imp1525 = permute(imp1525,[2 3 1]);
    imp1550 = permute(imp1550,[2 3 1]);
    imp1575 = permute(imp1575,[2 3 1]);% ʣ༾Ʊ̣˴ʡ
    for i=1:N
        if tcode(i)==2
            imp9700(i,:,:) = cumsum(imp9700(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp9725(i,:,:) = cumsum(imp9725(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp9725(i,:,:) = cumsum(imp9725(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp9725(i,:,:) = cumsum(imp9725(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp9800(i,:,:) = cumsum(imp9800(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp9825(i,:,:) = cumsum(imp9825(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp9850(i,:,:) = cumsum(imp9850(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp9875(i,:,:) = cumsum(imp9875(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp9900(i,:,:) = cumsum(imp9900(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp9925(i,:,:) = cumsum(imp9925(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp9950(i,:,:) = cumsum(imp9950(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp9975(i,:,:) = cumsum(imp9975(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0000(i,:,:) = cumsum(imp0000(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0025(i,:,:) = cumsum(imp0025(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0050(i,:,:) = cumsum(imp0050(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0075(i,:,:) = cumsum(imp0075(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0100(i,:,:) = cumsum(imp0100(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0125(i,:,:) = cumsum(imp0125(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0150(i,:,:) = cumsum(imp0150(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0175(i,:,:) = cumsum(imp0175(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0200(i,:,:) = cumsum(imp0200(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0225(i,:,:) = cumsum(imp0225(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0250(i,:,:) = cumsum(imp0250(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0275(i,:,:) = cumsum(imp0275(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0300(i,:,:) = cumsum(imp0300(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0325(i,:,:) = cumsum(imp0325(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0350(i,:,:) = cumsum(imp0350(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0375(i,:,:) = cumsum(imp0375(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0400(i,:,:) = cumsum(imp0400(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0425(i,:,:) = cumsum(imp0425(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0450(i,:,:) = cumsum(imp0450(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0475(i,:,:) = cumsum(imp0475(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0500(i,:,:) = cumsum(imp0500(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0525(i,:,:) = cumsum(imp0525(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0550(i,:,:) = cumsum(imp0550(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0575(i,:,:) = cumsum(imp0575(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0600(i,:,:) = cumsum(imp0600(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0625(i,:,:) = cumsum(imp0625(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0650(i,:,:) = cumsum(imp0650(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0675(i,:,:) = cumsum(imp0675(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0700(i,:,:) = cumsum(imp0700(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0725(i,:,:) = cumsum(imp0725(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0750(i,:,:) = cumsum(imp0750(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0775(i,:,:) = cumsum(imp0775(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0800(i,:,:) = cumsum(imp0800(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0825(i,:,:) = cumsum(imp0825(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0850(i,:,:) = cumsum(imp0850(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0875(i,:,:) = cumsum(imp0875(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0900(i,:,:) = cumsum(imp0900(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0925(i,:,:) = cumsum(imp0925(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0950(i,:,:) = cumsum(imp0950(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp0975(i,:,:) = cumsum(imp0975(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1000(i,:,:) = cumsum(imp1000(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1025(i,:,:) = cumsum(imp1025(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1050(i,:,:) = cumsum(imp1050(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1075(i,:,:) = cumsum(imp1075(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1100(i,:,:) = cumsum(imp1100(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1125(i,:,:) = cumsum(imp1125(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1150(i,:,:) = cumsum(imp1150(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1175(i,:,:) = cumsum(imp1175(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1200(i,:,:) = cumsum(imp1200(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1225(i,:,:) = cumsum(imp1225(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1250(i,:,:) = cumsum(imp1250(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1275(i,:,:) = cumsum(imp1275(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1300(i,:,:) = cumsum(imp1300(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1325(i,:,:) = cumsum(imp1325(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1350(i,:,:) = cumsum(imp1350(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1375(i,:,:) = cumsum(imp1375(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1400(i,:,:) = cumsum(imp1400(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1425(i,:,:) = cumsum(imp1425(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1450(i,:,:) = cumsum(imp1450(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1475(i,:,:) = cumsum(imp1475(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1500(i,:,:) = cumsum(imp1500(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1525(i,:,:) = cumsum(imp1525(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1550(i,:,:) = cumsum(imp1550(i,:,:),2)-ones(1,nhor,nrep/nthin);
            imp1575(i,:,:) = cumsum(imp1575(i,:,:),2)-ones(1,nhor,nrep/nthin);% ʣ༾Ʊ̣˴ʡ
        elseif tcode(i)==5
            imp9700(i,:,:) = exp(cumsum(imp9700(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp9725(i,:,:) = exp(cumsum(imp9725(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp9725(i,:,:) = exp(cumsum(imp9725(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp9725(i,:,:) = exp(cumsum(imp9725(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp9800(i,:,:) = exp(cumsum(imp9800(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp9825(i,:,:) = exp(cumsum(imp9825(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp9850(i,:,:) = exp(cumsum(imp9850(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp9875(i,:,:) = exp(cumsum(imp9875(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp9900(i,:,:) = exp(cumsum(imp9900(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp9925(i,:,:) = exp(cumsum(imp9925(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp9950(i,:,:) = exp(cumsum(imp9950(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp9975(i,:,:) = exp(cumsum(imp9975(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0000(i,:,:) = exp(cumsum(imp0000(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0025(i,:,:) = exp(cumsum(imp0025(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0050(i,:,:) = exp(cumsum(imp0050(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0075(i,:,:) = exp(cumsum(imp0075(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0100(i,:,:) = exp(cumsum(imp0100(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0125(i,:,:) = exp(cumsum(imp0125(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0150(i,:,:) = exp(cumsum(imp0150(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0175(i,:,:) = exp(cumsum(imp0175(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0200(i,:,:) = exp(cumsum(imp0200(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0225(i,:,:) = exp(cumsum(imp0225(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0250(i,:,:) = exp(cumsum(imp0250(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0275(i,:,:) = exp(cumsum(imp0275(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0300(i,:,:) = exp(cumsum(imp0300(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0325(i,:,:) = exp(cumsum(imp0325(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0350(i,:,:) = exp(cumsum(imp0350(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0375(i,:,:) = exp(cumsum(imp0375(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0400(i,:,:) = exp(cumsum(imp0400(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0425(i,:,:) = exp(cumsum(imp0425(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0450(i,:,:) = exp(cumsum(imp0450(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0475(i,:,:) = exp(cumsum(imp0475(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0500(i,:,:) = exp(cumsum(imp0500(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0525(i,:,:) = exp(cumsum(imp0525(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0550(i,:,:) = exp(cumsum(imp0550(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0575(i,:,:) = exp(cumsum(imp0575(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0600(i,:,:) = exp(cumsum(imp0600(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0625(i,:,:) = exp(cumsum(imp0625(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0650(i,:,:) = exp(cumsum(imp0650(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0675(i,:,:) = exp(cumsum(imp0675(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0700(i,:,:) = exp(cumsum(imp0700(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0725(i,:,:) = exp(cumsum(imp0725(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0750(i,:,:) = exp(cumsum(imp0750(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0775(i,:,:) = exp(cumsum(imp0775(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0800(i,:,:) = exp(cumsum(imp0800(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0825(i,:,:) = exp(cumsum(imp0825(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0850(i,:,:) = exp(cumsum(imp0850(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0875(i,:,:) = exp(cumsum(imp0875(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0900(i,:,:) = exp(cumsum(imp0900(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0925(i,:,:) = exp(cumsum(imp0925(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0950(i,:,:) = exp(cumsum(imp0950(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp0975(i,:,:) = exp(cumsum(imp0975(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1000(i,:,:) = exp(cumsum(imp1000(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1025(i,:,:) = exp(cumsum(imp1025(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1050(i,:,:) = exp(cumsum(imp1050(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1075(i,:,:) = exp(cumsum(imp1075(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1100(i,:,:) = exp(cumsum(imp1100(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1125(i,:,:) = exp(cumsum(imp1125(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1150(i,:,:) = exp(cumsum(imp1150(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1175(i,:,:) = exp(cumsum(imp1175(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1200(i,:,:) = exp(cumsum(imp1200(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1225(i,:,:) = exp(cumsum(imp1225(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1250(i,:,:) = exp(cumsum(imp1250(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1275(i,:,:) = exp(cumsum(imp1275(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1300(i,:,:) = exp(cumsum(imp1300(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1325(i,:,:) = exp(cumsum(imp1325(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1350(i,:,:) = exp(cumsum(imp1350(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1375(i,:,:) = exp(cumsum(imp1375(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1400(i,:,:) = exp(cumsum(imp1400(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1425(i,:,:) = exp(cumsum(imp1425(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1450(i,:,:) = exp(cumsum(imp1450(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1475(i,:,:) = exp(cumsum(imp1475(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1500(i,:,:) = exp(cumsum(imp1500(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1525(i,:,:) = exp(cumsum(imp1525(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1550(i,:,:) = exp(cumsum(imp1550(i,:,:),2)-ones(1,nhor,nrep/nthin));
            imp1575(i,:,:) = exp(cumsum(imp1575(i,:,:),2)-ones(1,nhor,nrep/nthin));% ʣ༾Ʊ̣˴ʡ
        end
    end
    imp9700 = permute(imp9700,[3 1 2]);
    imp9725 = permute(imp9725,[3 1 2]);
    imp9750 = permute(imp9750,[3 1 2]);
    imp9775 = permute(imp9775,[3 1 2]);
    imp9800 = permute(imp9800,[3 1 2]);
    imp9825 = permute(imp9825,[3 1 2]);
    imp9850 = permute(imp9850,[3 1 2]);
    imp9875 = permute(imp9875,[3 1 2]);
    imp9900 = permute(imp9900,[3 1 2]);
    imp9925 = permute(imp9925,[3 1 2]);
    imp9950 = permute(imp9950,[3 1 2]);
    imp9975 = permute(imp9975,[3 1 2]);
    imp0000 = permute(imp0000,[3 1 2]);
    imp0025 = permute(imp0025,[3 1 2]);
    imp0050 = permute(imp0050,[3 1 2]);
    imp0075 = permute(imp0075,[3 1 2]);
    imp0100 = permute(imp0100,[3 1 2]);
    imp0125 = permute(imp0125,[3 1 2]);
    imp0150 = permute(imp0150,[3 1 2]);
    imp0175 = permute(imp0175,[3 1 2]);
    imp0200 = permute(imp0200,[3 1 2]);
    imp0225 = permute(imp0225,[3 1 2]);
    imp0250 = permute(imp0250,[3 1 2]);
    imp0275 = permute(imp0275,[3 1 2]);
    imp0300 = permute(imp0300,[3 1 2]);
    imp0325 = permute(imp0325,[3 1 2]);
    imp0350 = permute(imp0350,[3 1 2]);
    imp0375 = permute(imp0375,[3 1 2]);
    imp0400 = permute(imp0400,[3 1 2]);
    imp0425 = permute(imp0425,[3 1 2]);
    imp0450 = permute(imp0450,[3 1 2]);
    imp0475 = permute(imp0475,[3 1 2]);
    imp0500 = permute(imp0500,[3 1 2]);
    imp0525 = permute(imp0525,[3 1 2]);
    imp0550 = permute(imp0550,[3 1 2]);
    imp0575 = permute(imp0575,[3 1 2]);
    imp0600 = permute(imp0600,[3 1 2]);
    imp0625 = permute(imp0625,[3 1 2]);
    imp0650 = permute(imp0650,[3 1 2]);
    imp0675 = permute(imp0675,[3 1 2]);
    imp0700 = permute(imp0700,[3 1 2]);
    imp0725 = permute(imp0725,[3 1 2]);
    imp0750 = permute(imp0750,[3 1 2]);
    imp0775 = permute(imp0775,[3 1 2]);
    imp0800 = permute(imp0800,[3 1 2]);
    imp0825 = permute(imp0825,[3 1 2]);
    imp0850 = permute(imp0850,[3 1 2]);
    imp0875 = permute(imp0875,[3 1 2]);
    imp0900 = permute(imp0900,[3 1 2]);
    imp0925 = permute(imp0925,[3 1 2]);
    imp0950 = permute(imp0950,[3 1 2]);
    imp0975 = permute(imp0975,[3 1 2]);
    imp1000 = permute(imp1000,[3 1 2]);
    imp1025 = permute(imp1025,[3 1 2]);
    imp1050 = permute(imp1050,[3 1 2]);
    imp1075 = permute(imp1075,[3 1 2]);
    imp1100 = permute(imp1100,[3 1 2]);
    imp1125 = permute(imp1125,[3 1 2]);
    imp1150 = permute(imp1150,[3 1 2]);
    imp1175 = permute(imp1175,[3 1 2]);
    imp1200 = permute(imp1200,[3 1 2]);
    imp1225 = permute(imp1225,[3 1 2]);
    imp1250 = permute(imp1250,[3 1 2]);
    imp1275 = permute(imp1275,[3 1 2]);
    imp1300 = permute(imp1300,[3 1 2]);
    imp1325 = permute(imp1325,[3 1 2]);
    imp1350 = permute(imp1350,[3 1 2]);
    imp1375 = permute(imp1375,[3 1 2]);
    imp1400 = permute(imp1400,[3 1 2]);
    imp1425 = permute(imp1425,[3 1 2]);
    imp1450 = permute(imp1450,[3 1 2]);
    imp1475 = permute(imp1475,[3 1 2]);
    imp1500 = permute(imp1500,[3 1 2]);
    imp1525 = permute(imp1525,[3 1 2]);
    imp1550 = permute(imp1550,[3 1 2]);
    imp1575 = permute(imp1575,[3 1 2]);
    imp9700xy=squeeze(quantile(imp9700,0.5));
    imp9725xy=squeeze(quantile(imp9725,0.5));
    imp9750xy=squeeze(quantile(imp9750,0.5));
    imp9775xy=squeeze(quantile(imp9775,0.5));
    imp9800xy=squeeze(quantile(imp9800,0.5));
    imp9825xy=squeeze(quantile(imp9825,0.5));
    imp9850xy=squeeze(quantile(imp9850,0.5));
    imp9875xy=squeeze(quantile(imp9875,0.5));
    imp9900xy=squeeze(quantile(imp9900,0.5));
    imp9925xy=squeeze(quantile(imp9925,0.5));
    imp9950xy=squeeze(quantile(imp9950,0.5));
    imp9975xy=squeeze(quantile(imp9975,0.5));
    imp0000xy=squeeze(quantile(imp0000,0.5));
    imp0025xy=squeeze(quantile(imp0025,0.5));
    imp0050xy=squeeze(quantile(imp0050,0.5));
    imp0075xy=squeeze(quantile(imp0075,0.5));
    imp0100xy=squeeze(quantile(imp0100,0.5));
    imp0125xy=squeeze(quantile(imp0125,0.5));
    imp0150xy=squeeze(quantile(imp0150,0.5));
    imp0175xy=squeeze(quantile(imp0175,0.5));
    imp0200xy=squeeze(quantile(imp0200,0.5));
    imp0225xy=squeeze(quantile(imp0225,0.5));
    imp0250xy=squeeze(quantile(imp0250,0.5));
    imp0275xy=squeeze(quantile(imp0275,0.5));
    imp0300xy=squeeze(quantile(imp0300,0.5));
    imp0325xy=squeeze(quantile(imp0325,0.5));
    imp0350xy=squeeze(quantile(imp0350,0.5));
    imp0375xy=squeeze(quantile(imp0375,0.5));
    imp0400xy=squeeze(quantile(imp0400,0.5));
    imp0425xy=squeeze(quantile(imp0425,0.5));
    imp0450xy=squeeze(quantile(imp0450,0.5));
    imp0475xy=squeeze(quantile(imp0475,0.5));
    imp0500xy=squeeze(quantile(imp0500,0.5));
    imp0525xy=squeeze(quantile(imp0525,0.5));
    imp0550xy=squeeze(quantile(imp0550,0.5));
    imp0575xy=squeeze(quantile(imp0575,0.5));
    imp0600xy=squeeze(quantile(imp0600,0.5));
    imp0625xy=squeeze(quantile(imp0625,0.5));
    imp0650xy=squeeze(quantile(imp0650,0.5));
    imp0675xy=squeeze(quantile(imp0675,0.5));
    imp0700xy=squeeze(quantile(imp0700,0.5));
    imp0725xy=squeeze(quantile(imp0725,0.5));
    imp0750xy=squeeze(quantile(imp0750,0.5));
    imp0775xy=squeeze(quantile(imp0775,0.5));
    imp0800xy=squeeze(quantile(imp0800,0.5));
    imp0825xy=squeeze(quantile(imp0825,0.5));
    imp0850xy=squeeze(quantile(imp0850,0.5));
    imp0875xy=squeeze(quantile(imp0875,0.5));
    imp0900xy=squeeze(quantile(imp0900,0.5));
    imp0925xy=squeeze(quantile(imp0925,0.5));
    imp0950xy=squeeze(quantile(imp0950,0.5));
    imp0975xy=squeeze(quantile(imp0975,0.5));
    imp1000xy=squeeze(quantile(imp1000,0.5));
    imp1025xy=squeeze(quantile(imp1025,0.5));
    imp1050xy=squeeze(quantile(imp1050,0.5));
    imp1075xy=squeeze(quantile(imp1075,0.5));
    imp1100xy=squeeze(quantile(imp1100,0.5));
    imp1125xy=squeeze(quantile(imp1125,0.5));
    imp1150xy=squeeze(quantile(imp1150,0.5));
    imp1175xy=squeeze(quantile(imp1175,0.5));
    imp1200xy=squeeze(quantile(imp1200,0.5));
    imp1225xy=squeeze(quantile(imp1225,0.5));
    imp1250xy=squeeze(quantile(imp1250,0.5));
    imp1275xy=squeeze(quantile(imp1275,0.5));
    imp1300xy=squeeze(quantile(imp1300,0.5));
    imp1325xy=squeeze(quantile(imp1325,0.5));
    imp1350xy=squeeze(quantile(imp1350,0.5));
    imp1375xy=squeeze(quantile(imp1375,0.5));
    imp1400xy=squeeze(quantile(imp1400,0.5));
    imp1425xy=squeeze(quantile(imp1425,0.5));
    imp1450xy=squeeze(quantile(imp1450,0.5));
    imp1475xy=squeeze(quantile(imp1475,0.5));
    imp1500xy=squeeze(quantile(imp1500,0.5));
    imp1525xy=squeeze(quantile(imp1525,0.5));
    imp1550xy=squeeze(quantile(imp1550,0.5));
    imp1575xy=squeeze(quantile(imp1575,0.5)); % ʣ༾Ʊ̣˴ʡ
    gdpz=[imp9700xy(end-1,:)',imp9725xy(end-1,:)',imp9750xy(end-1,:)',imp9775xy(end-1,:)',...
        imp9800xy(end-1,:)',imp9825xy(end-1,:)',imp9850xy(end-1,:)',imp9875xy(end-1,:)',...
        imp9900xy(end-1,:)',imp9925xy(end-1,:)',imp9950xy(end-1,:)',imp9975xy(end-1,:)',...
        imp0000xy(end-1,:)',imp0025xy(end-1,:)',imp0050xy(end-1,:)',imp0075xy(end-1,:)',...
        imp0100xy(end-1,:)',imp0125xy(end-1,:)',imp0150xy(end-1,:)',imp0175xy(end-1,:)',...
        imp0200xy(end-1,:)',imp0225xy(end-1,:)',imp0250xy(end-1,:)',imp0275xy(end-1,:)',...
        imp0300xy(end-1,:)',imp0325xy(end-1,:)',imp0350xy(end-1,:)',imp0375xy(end-1,:)',...
        imp0400xy(end-1,:)',imp0425xy(end-1,:)',imp0450xy(end-1,:)',imp0475xy(end-1,:)',...
        imp0500xy(end-1,:)',imp0525xy(end-1,:)',imp0550xy(end-1,:)',imp0575xy(end-1,:)',...
        imp0600xy(end-1,:)',imp0625xy(end-1,:)',imp0650xy(end-1,:)',imp0675xy(end-1,:)',...
        imp0700xy(end-1,:)',imp0725xy(end-1,:)',imp0750xy(end-1,:)',imp0775xy(end-1,:)',...
        imp0800xy(end-1,:)',imp0825xy(end-1,:)',imp0850xy(end-1,:)',imp0875xy(end-1,:)',...
        imp0900xy(end-1,:)',imp0925xy(end-1,:)',imp0950xy(end-1,:)',imp0975xy(end-1,:)',...
        imp1000xy(end-1,:)',imp1025xy(end-1,:)',imp1050xy(end-1,:)',imp1075xy(end-1,:)',...
        imp1100xy(end-1,:)',imp1125xy(end-1,:)',imp1150xy(end-1,:)',imp1175xy(end-1,:)',...
        imp1200xy(end-1,:)',imp1225xy(end-1,:)',imp1250xy(end-1,:)',imp1275xy(end-1,:)',...
        imp1300xy(end-1,:)',imp1325xy(end-1,:)',imp1350xy(end-1,:)',imp1375xy(end-1,:)',...
        imp1400xy(end-1,:)',imp1425xy(end-1,:)',imp1450xy(end-1,:)',imp1475xy(end-1,:)',...
        imp1500xy(end-1,:)',imp1525xy(end-1,:)',imp1550xy(end-1,:)',imp1575xy(end-1,:)',...
    ]' % ʣ༾Ʊ̣˴ʡ
    gdpx=[1:1:24]
    gdpy=[1997.00:0.25:2015.75];
    surf(gdpx,gdpy,gdpz)
    set(gca,'xdir','reverse')
    qus = [.10, .50, .90]; 
    imp9700xy=squeeze(quantile(imp9700,qus));
    imp9725xy=squeeze(quantile(imp9725,qus));
    imp9750xy=squeeze(quantile(imp9750,qus));
    imp9775xy=squeeze(quantile(imp9775,qus));
    imp9800xy=squeeze(quantile(imp9800,qus));
    imp9825xy=squeeze(quantile(imp9825,qus));
    imp9850xy=squeeze(quantile(imp9850,qus));
    imp9875xy=squeeze(quantile(imp9875,qus));
    imp9900xy=squeeze(quantile(imp9900,qus));
    imp9925xy=squeeze(quantile(imp9925,qus));
    imp9950xy=squeeze(quantile(imp9950,qus));
    imp9975xy=squeeze(quantile(imp9975,qus));
    imp0000xy=squeeze(quantile(imp0000,qus));
    imp0025xy=squeeze(quantile(imp0025,qus));
    imp0050xy=squeeze(quantile(imp0050,qus));
    imp0075xy=squeeze(quantile(imp0075,qus));
    imp0100xy=squeeze(quantile(imp0100,qus));
    imp0125xy=squeeze(quantile(imp0125,qus));
    imp0150xy=squeeze(quantile(imp0150,qus));
    imp0175xy=squeeze(quantile(imp0175,qus));
    imp0200xy=squeeze(quantile(imp0200,qus));
    imp0225xy=squeeze(quantile(imp0225,qus));
    imp0250xy=squeeze(quantile(imp0250,qus));
    imp0275xy=squeeze(quantile(imp0275,qus));
    imp0300xy=squeeze(quantile(imp0300,qus));
    imp0325xy=squeeze(quantile(imp0325,qus));
    imp0350xy=squeeze(quantile(imp0350,qus));
    imp0375xy=squeeze(quantile(imp0375,qus));
    imp0400xy=squeeze(quantile(imp0400,qus));
    imp0425xy=squeeze(quantile(imp0425,qus));
    imp0450xy=squeeze(quantile(imp0450,qus));
    imp0475xy=squeeze(quantile(imp0475,qus));
    imp0500xy=squeeze(quantile(imp0500,qus));
    imp0525xy=squeeze(quantile(imp0525,qus));
    imp0550xy=squeeze(quantile(imp0550,qus));
    imp0575xy=squeeze(quantile(imp0575,qus));
    imp0600xy=squeeze(quantile(imp0600,qus));
    imp0625xy=squeeze(quantile(imp0625,qus));
    imp0650xy=squeeze(quantile(imp0650,qus));
    imp0675xy=squeeze(quantile(imp0675,qus));
    imp0700xy=squeeze(quantile(imp0700,qus));
    imp0725xy=squeeze(quantile(imp0725,qus));
    imp0750xy=squeeze(quantile(imp0750,qus));
    imp0775xy=squeeze(quantile(imp0775,qus));
    imp0800xy=squeeze(quantile(imp0800,qus));
    imp0825xy=squeeze(quantile(imp0825,qus));
    imp0850xy=squeeze(quantile(imp0850,qus));
    imp0875xy=squeeze(quantile(imp0875,qus));
    imp0900xy=squeeze(quantile(imp0900,qus));
    imp0925xy=squeeze(quantile(imp0925,qus));
    imp0950xy=squeeze(quantile(imp0950,qus));
    imp0975xy=squeeze(quantile(imp0975,qus));
    imp1000xy=squeeze(quantile(imp1000,qus));
    imp1025xy=squeeze(quantile(imp1025,qus));
    imp1050xy=squeeze(quantile(imp1050,qus));
    imp1075xy=squeeze(quantile(imp1075,qus));
    imp1100xy=squeeze(quantile(imp1100,qus));
    imp1125xy=squeeze(quantile(imp1125,qus));
    imp1150xy=squeeze(quantile(imp1150,qus));
    imp1175xy=squeeze(quantile(imp1175,qus));
    imp1200xy=squeeze(quantile(imp1200,qus));
    imp1225xy=squeeze(quantile(imp1225,qus));
    imp1250xy=squeeze(quantile(imp1250,qus));
    imp1275xy=squeeze(quantile(imp1275,qus));
    imp1300xy=squeeze(quantile(imp1300,qus));
    imp1325xy=squeeze(quantile(imp1325,qus));
    imp1350xy=squeeze(quantile(imp1350,qus));
    imp1375xy=squeeze(quantile(imp1375,qus));
    imp1400xy=squeeze(quantile(imp1400,qus));
    imp1425xy=squeeze(quantile(imp1425,qus));
    imp1450xy=squeeze(quantile(imp1450,qus));
    imp1475xy=squeeze(quantile(imp1475,qus));
    imp1500xy=squeeze(quantile(imp1500,qus));
    imp1525xy=squeeze(quantile(imp1525,qus));
    imp1550xy=squeeze(quantile(imp1550,qus));
    imp1575xy=squeeze(quantile(imp1575,qus));% ʣ༾Ʊ̣˴ʡ
    figure
    set(0,'DefaultAxesColorOrder',[0 0 0],...      
        'DefaultAxesLineStyleOrder','-|.|-')    
    
    subplot(1,2,1)
    plot(yearlab,Fr0(3:end,1))
    xlim([yearlab(1) yearlab(end)])
    grid on
    hold on
    subplot(1,2,2)
    plot(yearlab,sigmean(:,1)) 
    xlim([yearlab(1) yearlab(end)])
    grid on
  figure      
    set(0,'DefaultAxesColorOrder',[0 0 0],...
        'DefaultAxesLineStyleOrder','--|-|--')
    subplot(3,3,1)
    plot(1:nhor,squeeze(imp9825XY(:,end-3,:)))
    hold;
    plot(zeros(1,nhor),'-')
    title('Impulse response of shi, 1998:Q1')
    xlim([1 nhor])
    set(gca,'XTick',0:4:nhor)
    subplot(3,3,2)
    plot(1:nhor,squeeze(imp0975XY(:,end-3,:)))
    hold;
    plot(zeros(1,nhor),'-')
    title('Impulse response of shi, 2009:Q1')
    xlim([1 nhor])
    set(gca,'XTick',0:4:nhor)    
    subplot(3,3,3)
    plot(1:nhor,squeeze(imp1525XY(:,end-3,:)))
    hold;
    plot(zeros(1,nhor),'-')
    title('Impulse response of shi, 2015:Q1')
    xlim([1 nhor])
    set(gca,'XTick',0:4:nhor)    
    subplot(3,3,4)
    plot(1:nhor,squeeze(imp9825XY(:,end-2,:)))
    hold;
    plot(zeros(1,nhor),'-')
    title('Impulse response of szi, 1998:Q1')
    xlim([1 nhor])
    set(gca,'XTick',0:4:nhor)    
    subplot(3,3,5)
    plot(1:nhor,squeeze(imp0975XY(:,end-2,:)))
    hold;
    plot(zeros(1,nhor),'-')
    title('Impulse response of szi, 2009:Q1')
    xlim([1 nhor])
    set(gca,'XTick',0:4:nhor)    
    subplot(3,3,6)
    plot(1:nhor,squeeze(imp1525XY(:,end-2,:)))
    hold;
    plot(zeros(1,nhor),'-')
    title('Impulse response of szi, 2015:Q1')
    xlim([1 nhor])
    set(gca,'XTick',0:4:nhor)    
    subplot(3,3,7)
    plot(1:nhor,squeeze(imp9825XY(:,end-1,:)))
    hold;
    plot(zeros(1,nhor),'-')
    title('Impulse response of rate7, 1998:Q1')
    xlim([1 nhor])
    set(gca,'XTick',0:4:nhor)    
    subplot(3,3,8)
    plot(1:nhor,squeeze(imp0975XY(:,end-1,:)))
    hold;
    plot(zeros(1,nhor),'-')
    title('Impulse response of rate7, 2009:Q1')
    xlim([1 nhor])
    set(gca,'XTick',0:4:nhor)
    subplot(3,3,9)
    plot(1:nhor,squeeze(imp1525XY(:,end-1,:)))
    hold;
    plot(zeros(1,nhor),'-')
    title('Impulse response of rate7, 2015:Q1')
    xlim([1 nhor])
    set(gca,'XTick',0:4:nhor)    
clc;
toc; 